- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# cloudfront_invalidation – create invalidations for aws cloudfront distributions

New in version 2.5.

- Synopsis

- Requirements

- Parameters

- Notes

- Examples

- Return Values

- Status

## Synopsis

- Allows for invalidation of a batch of paths for a CloudFront distribution.

## Requirements

The below requirements are needed on the host that executes this module.

- boto

- boto3 >= 1.0.0

- python >= 2.6

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
alias - |  | The alias of the cloudfront distribution to invalidate paths for. Can be specified instead of distribution_id.
aws_access_key string |  | AWS access key. If not set then the value of the AWS_ACCESS_KEY_ID, AWS_ACCESS_KEY or EC2_ACCESS_KEY environment variable is used. aliases: ec2_access_key, access_key
aws_secret_key string |  | AWS secret key. If not set then the value of the AWS_SECRET_ACCESS_KEY, AWS_SECRET_KEY, or EC2_SECRET_KEY environment variable is used. aliases: ec2_secret_key, secret_key
caller_reference - | Default: "current datetime stamp" | A unique reference identifier for the invalidation paths.
debug_botocore_endpoint_logs boolean added in 2.8 | Choices: no ← yes | Use a botocore.endpoint logger to parse the unique (rather than total) "resource:action" API calls made during a task, outputing the set to the resource_actions key in the task results. Use the aws_resource_action callback to output to total list made during a playbook. The ANSIBLE_DEBUG_BOTOCORE_LOGS environment variable may also be used.
distribution_id - |  | The id of the cloudfront distribution to invalidate paths for. Can be specified instead of the alias.
ec2_url string |  | Url to use to connect to EC2 or your Eucalyptus cloud (by default the module will use EC2 endpoints). Ignored for modules where region is required. Must be specified for all other modules if region is not used. If not set then the value of the EC2_URL environment variable, if any, is used.
profile string |  | Uses a boto profile. Only works with boto >= 2.24.0.
region string |  | The AWS region to use. If not specified then the value of the AWS_REGION or EC2_REGION environment variable, if any, is used. See http://docs.aws.amazon.com/general/latest/gr/rande.html#ec2_region aliases: aws_region, ec2_region
security_token string |  | AWS STS security token. If not set then the value of the AWS_SECURITY_TOKEN or EC2_SECURITY_TOKEN environment variable is used. aliases: access_token
target_paths - / required |  | A list of paths on the distribution to invalidate. Each path should begin with '/'. Wildcards are allowed. eg. '/foo/bar/*'
validate_certs boolean | Choices: no yes ← | When set to "no", SSL certificates will not be validated for boto versions >= 2.6.0.

## Notes

Note

- does not support check mode

- If parameters are not set within the module, the following environment variables can be used in decreasing order of precedence `AWS_URL` or `EC2_URL`, `AWS_ACCESS_KEY_ID` or `AWS_ACCESS_KEY` or `EC2_ACCESS_KEY`, `AWS_SECRET_ACCESS_KEY` or `AWS_SECRET_KEY` or `EC2_SECRET_KEY`, `AWS_SECURITY_TOKEN` or `EC2_SECURITY_TOKEN`, `AWS_REGION` or `EC2_REGION`

- Ansible uses the boto configuration file (typically ~/.boto) if no credentials are provided. See https://boto.readthedocs.io/en/latest/boto_config_tut.html

- `AWS_REGION` or `EC2_REGION` can be typically be used to specify the AWS region, when required, but this can also be configured in the boto config file

## Examples

    - name: create a batch of invalidations using a distribution_id for a reference
      cloudfront_invalidation:
        distribution_id: E15BU8SDCGSG57
        caller_reference: testing 123
        target_paths:
          - /testpathone/test1.css
          - /testpathtwo/test2.js
          - /testpaththree/test3.ss

    - name: create a batch of invalidations using an alias as a reference and one path using a wildcard match
      cloudfront_invalidation:
        alias: alias.test.com
        caller_reference: testing 123
        target_paths:
          - /testpathone/test4.css
          - /testpathtwo/test5.js
          - /testpaththree/*

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
invalidation complex | always | The invalidation's information.
| create_time string | always | The date and time the invalidation request was first made. Sample: 2018-02-01T15:50:41.159000+00:00
| id string | always | The identifier for the invalidation request. Sample: I2G9MOWJZFV612
| invalidation_batch complex | always | The current invalidation information for the batch request.
|  | caller_reference string | always | The value used to uniquely identify an invalidation request. Sample: testing 123
|  | paths complex | always | A dict that contains information about the objects that you want to invalidate.
|  |  | items list | always | A list of the paths that you want to invalidate. Sample: ['/testpathtwo/test2.js', '/testpathone/test1.css', '/testpaththree/test3.ss']
|  |  | quantity integer | always | The number of objects that you want to invalidate. Sample: 3
| status string | always | The status of the invalidation request. Sample: Completed
location string | always | The fully qualified URI of the distribution and invalidation batch request. Sample: https://cloudfront.amazonaws.com/2017-03-25/distribution/E1ZID6KZJECZY7/invalidation/I2G9MOWJZFV622

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]

- This module is maintained by the Ansible Community. [community]

### Authors

- Willem van Ketwich (@wilvk)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.